/**************************************************************************************************

Copyright (c) 2007-2012   Tsunehiko Kato

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  "mtk_nearby_galaxies.h"
#include  "mitaka.h"
#include  "mtk_elliptical_galaxy.h"
#include  "mtk_objects.h"
#include  "mtk_label.h"
#include  "mtk_switches.h"
#include  "mtk_colors.h"
#include  "mtk_file.h"
#include  "mtk_OpenGL.h"
#include  "mtk_gl_common.h"
#include  <vector>
#include  <map>

#include  "mtk_solar_system.h"
#include  "mtk_our_galaxy.h"
#include  "mtk_calc_alpha.h"
#include  "mtk_draw_common.h"



//------------
//  Typedefs
//------------

//--  Draw Type
enum {
	GALAXY_DRAW_TYPE_NORMAL,
	GALAXY_DRAW_TYPE_CD
};

//--  Texture Type
enum {
	GALAXY_MTY_UNDETERMINED,
	GALAXY_MTY_ELLIPTICAL,
	GALAXY_MTY_S0,
	GALAXY_MTY_SPIRAL,
	GALAXY_MTY_IRREGULAR,
	GALAXY_MTY_LMC,
	GALAXY_MTY_SMC,
	GALAXY_MTY_M31
};





//-----------
//  Objects
//-----------
//--  Nearby Galaxies
static vector<nearby_galaxy2>	NGLX;
//--  Ref. tables of nearby galaxy catalogue no and index
static std::map<int, int>		NGC_table, UGC_table, PGC_table, Tully_table, undefined_table;



//--------------------
//  Color / Textures
//--------------------
const float galaxy_B_V[5] = { 0.0, 0.96, 0.85, 0.57, 0.27 };
static RGBf		galaxy_color[5];
static GLuint	texGalaxy;
static GLuint	dlGalaxy;




//---------------
//  Load / Init
//---------------

//--  Init galaxy color
void
init_galaxy_color()
{
	for (int i=0; i<5; ++i) {
        float Tc = B_V_to_Tc( galaxy_B_V[i] );
		RGBf rgb = blackbody_color(Tc);
		galaxy_color[i] = correct_RGB( rgb );
	}
}


int
read_a_nearby_galaxy_record(FILE* fp, nearby_galaxy2& gl)
{
	//--- read data
	int count;
	count = fread(&gl.eqPos.RAdeg,		sizeof(gl.eqPos.RAdeg),			1, fp);
	if (count < 1)  return FILE_FAILED;
	fread(&gl.eqPos.DEdeg,	sizeof(gl.eqPos.DEdeg),		1, fp);
	fread(&gl.distance,		sizeof(gl.distance),		1, fp);
	fread(&gl.D,			sizeof(gl.D),				1, fp);
	fread(&gl.d_D,			sizeof(gl.d_D),				1, fp);
	fread(&gl.mtype,		sizeof(gl.mtype),			1, fp);
	fread(&gl.group,		sizeof(gl.group),			1, fp);
	fread(&gl.chCatalogue,	sizeof(gl.chCatalogue),		1, fp);
	fread(&gl.Catalogue_no,	sizeof(gl.Catalogue_no),	1, fp);

	//--- a (in pc)
	gl.R = 0.5 * (pi/180.0 * 1.0/60.0) * gl.D * gl.distance;

	//--- Vʏ̈ʒuiPʔaj
	vector3f Cxyz = gl.eqPos.get_dirc_vec();

	//--- SW
	gl.xyz  = M_R2E * ( gl.distance * Cxyz );

	//---  Draw type
	if (gl.chCatalogue=='N' && gl.Catalogue_no == 4486) {
		gl.dtype = GALAXY_DRAW_TYPE_CD;			// M87
	} else {
		gl.dtype = GALAXY_DRAW_TYPE_NORMAL;
	}

	return  FILE_SUCCESS;
}


bool
read_nearby_galaxy_data(FILE* fp)
{
	int  res;
	nearby_galaxy2 gl;
	mtk_object  obj;

	while (true) {
		res = read_a_nearby_galaxy_record(fp, gl);

		if (res == FILE_FAILED)		break;
		
		if (res == FILE_SUCCESS)	{
			int idx = NGLX.size();
			int cat_no = gl.Catalogue_no;

			char key[256];
			switch (gl.chCatalogue) {
				case 'N':	//  NGC
					NGC_table.insert( pair<int, int>(cat_no, idx) );
					sprintf(key, "NGC%d", cat_no);
					break;
				case 'U':	//  UGC
					UGC_table.insert( pair<int, int>(cat_no, idx) );
					sprintf(key, "UGC%d", cat_no);
					break;
				case 'P':	// PGC
					PGC_table.insert( pair<int, int>(cat_no, idx) );
					sprintf(key, "PGC%d", cat_no);
					break;
				case 'T':	// Tully
					Tully_table.insert( pair<int, int>(cat_no, idx) );
					sprintf(key, "Tully%d", cat_no);
					break;
				case '*':	// Undefined
					undefined_table.insert( pair<int, int>(cat_no, idx) );
					sprintf(key, "UndefinedNBG%d", idx);
					break;
				default:
					break;
			}

			//--  Register a galaxy
			obj.init(OBJ_TYPE_NEARBY_GALAXY, idx, 0.0f, true);
			int obj_idx = register_object(obj, key);

			gl.name_select = false;
			gl.obj_idx = obj_idx;
			gl.label_obj_idx = -1;
			NGLX.push_back(gl);
		}
	}

	return  true;
}



//--------
//  Name
//--------
void
load_nearby_galaxy_names(FILE* fp)
{
	const int BUF_SIZE = 200;
	char buf[BUF_SIZE], buf2[BUF_SIZE];
	char name_E[40], name_J[70];

	while (true) {

		//-- Read one line
		if ( !read_one_line(fp, buf, BUF_SIZE) ) break;

		//-- Catalogue type
		char cat_type = buf[0];

		//-- Catalogue number
		int no;
		if ( !extract_string(buf, 1, 7, buf2) ) continue;
		sscanf(buf2, "%ld", &no);

		//-- Index
		int idx;
		switch (cat_type) {
			case 'N':	// NGC
				{
					map<int, int>::const_iterator it = NGC_table.find( no );
					if (it==NGC_table.end())  continue;
					idx = it->second;
				}
				break;
			case 'U':	// UGC
				{
					map<int, int>::const_iterator it = UGC_table.find( no );
					if (it==UGC_table.end())  continue;
					idx = it->second;
				};
				break;
			case 'P':	// PGC
				{
					map<int, int>::const_iterator it = PGC_table.find( no );
					if (it==PGC_table.end())  continue;
					idx = it->second;
				};
				break;
			case 'T':	// Tully
				{
					map<int, int>::const_iterator it = Tully_table.find( no );
					if (it==Tully_table.end())  continue;
					idx = it->second;
				};
				break;
			case '*':	// Undefined
				{
					map<int, int>::const_iterator it = undefined_table.find( no );
					if (it==undefined_table.end())  continue;
					idx = it->second;
				};
				break;
			default:
				continue;
		}

		//-- Name
		bool res_E, res_J;
		res_E = extract_string(buf, 10, 39, name_E);
		res_J = extract_string(buf, 40, 90, name_J);
		if (!res_E)  continue;
		if (!res_J)  strcpy(name_J, name_E);


		nearby_galaxy2&  gl = NGLX[idx];


		//-- Select
		bool bSelect;
		bSelect = (buf[9] != ' ');
		gl.name_select = bSelect;


		//--  Register label
		int obj_idx = gl.obj_idx;
		float R = 1.4 * gl.R;
		float thc = 8 * D2R;

		char str[256];
		sprintf(str, "NearbyGalaxyLabel%d", idx);
		gl.label_obj_idx = add_label( name_J, name_E, obj_idx, MTK_COLOR_NAME_OBJECT, 1.0f, get_object_name_size(), R, thc, true, str );
	}
}



bool
load_nearby_galaxies(const directory& dir)
{
	//---  Init color
	init_galaxy_color();

	//---  Load data
	FILE* fp = dir.fopen("NBG.dat", "rb");
	if (fp == NULL)  return false;
	bool res = read_nearby_galaxy_data(fp);
	fclose(fp);
	if ( !res ) return  false;

	//---  Load names
	fp = dir.fopen("nearby_galaxies_name.dat", "rt");
	if (fp != NULL) {
		load_nearby_galaxy_names(fp);
		fclose(fp);
	}

	return  res;
}



//------------
//  Textures
//------------
void
load_galaxies_textures()
{
	texGalaxy = LoadTexture("galaxy_class.png", TexShrinkRate);
}



//-------------------------------------------
//  ߖT͂̃C[WpfBXvCXg̏
//-------------------------------------------
void
init_galaxy_display_list()
{
	dlGalaxy = glGenLists(8);
	for (int i=0; i<8; ++i) {
		float du = 1.0f/8.0f;
		float u1 = du*i;
		float u2 = du*(i+1);
		
		glNewList(dlGalaxy+i, GL_COMPILE);
			glBegin(GL_QUADS);
				glTexCoord2f(u2,1);		glVertex3f(1,1,0);
				glTexCoord2f(u1,1);		glVertex3f(-1,1,0);
				glTexCoord2f(u1,0);		glVertex3f(-1,-1,0);
				glTexCoord2f(u2,0);		glVertex3f(1,-1,0);
			glEnd();
		glEndList();
	}
}



//
//
//
nearby_galaxy2&
get_nearby_galaxy(int idx)
{
	return  NGLX[idx];
}


//------------
//  Position
//------------
vector3d
get_nearby_galaxy_position(int idx)
{
	return  NGLX[idx].xyz;
}



//----------
//  Radius
//----------
double
get_nearby_galaxy_radius(int idx)
{
	return  NGLX[idx].R;
}



//---------
//  Scale
//---------
double
get_scale_nearby_galaxy(int idx)
{
	return  30.0 * get_nearby_galaxy_radius(idx);
}



//---------
//  Label
//---------
const double nbg_lc1 = 10000;
const double nbg_lc2 = 30000;


bool
is_nearby_galaxy_label_visible(const mtk_draw_struct& ds, int idx)
{
	if ( !(swGalaxy & GLXY_NEARBY_GALAXY) )  return false;
	if ( !test_disp_switch(DISPSW_PLANET, DISPM_NAME) )  return false;
	if ( ds.cnorm < nbg_lc1 )  return  false;
	if ( (swStar & STAR_NAME_SELECT) && !NGLX[idx].name_select )  return  false;

	return  true;
}


float
get_nearby_galaxy_label_alpha(const mtk_draw_struct& ds, int idx)
{
	const double lc = ds.cnorm;
	if (lc < nbg_lc2) {
		return  (lc - nbg_lc1) / (nbg_lc2 - nbg_lc1);
	}

	//****
	const mtk_object& tgt = get_object(ds.tgt_ID);
	if ( tgt.get_type() == OBJ_TYPE_NEARBY_GALAXY &&  tgt.get_index() == idx) {
		//  ͌nxƓ
		const float scl1 = 1e8;
		const float scl2 = 1e9;
		const float scale = ds.scale;
		if (scale > scl2)  return 0.0f;
		if (scale > scl1) {
			return  1 - (scale - scl1)/(scl2 - scl1);
		} else {
			return 1.0f;
		}
	}
	//****

	const vector3d   pos = get_nearby_galaxy_position(idx);
	const vector3d  cpos = ds.camera.get_pos();
	const vector3d  rpos = pos - cpos;
	const double l = rpos.norm();

	const vector3d  gpos = pos - get_our_galaxy_position();
	float  Rv  = 0.5f * gpos.norm();
	float  Dth = 2.0f * Rv / l;
	float af1, af2;
	af1 = calc_alpha_by_apparent_diameter( Dth );
	if (af1 < 0.01f)  return 0.0f;

	const vector3d  tpos = pos - ds.tgt_pos;
	Rv = 0.5f * tpos.norm();
	Dth = 2.0f * Rv / l;
	af2 = calc_alpha_by_apparent_diameter( Dth );
	if (af2 < 0.01f)  return 0.0f;

	return  (af1 < af2)  ?  af1  :  af2;
}



//------------------
//  Landing radius
//------------------
double
get_landing_radius_nearby_galaxy(int idx)
{
	return  0.3 * get_nearby_galaxy_radius(idx);
}



//----------------
//  Prepare draw
//----------------
bool
prepare_draw_nearby_galaxy(const mtk_draw_struct& ds, int idx, double* pRb, double* pRh, float* pAlp)
{
	//---  Visible
	if (! (swGalaxy & GLXY_NEARBY_GALAXY) )  return false;



	const double  scale = ds.scale;
	if (scale > 2e11)	return false;

	const double cnorm = ds.cnorm;
	float af0 = 1.0f;
	if (cnorm < 3e4) {
		af0 = 1 - (3e4 - cnorm)/(3e4 - 1e4);
	}
	if (af0 < 0.01)		return false;


	//---  Radius
	*pRb = *pRh = 0.3 * get_nearby_galaxy_radius(idx);
	*pAlp = af0;


	return  true;
}



//--------
//  Draw
//--------
void
draw_a_nearby_galaxy(const mtk_draw_struct& ds, int idx, const vector3d& rpos, const double& scl)
{
	const float screen_z = get_screen_z();
	const float scale = ds.scale;
	const double cnorm = ds.cnorm;
	
	//*********
	float af0 = 1.0f;

	if (cnorm > 1e9) {
		af0 = 1e9/cnorm;
	} else if (cnorm < 3e4) {
		af0 = 1 - (3e4 - cnorm)/(3e4 - 1e4);
	}
	if (af0 < 0.01)		return;


	if (scale > 2e11)  return;
	//**********


	const vector3d target_pos = ds.tgt_pos;
	const vector3d camera_pos = ds.camera.get_pos();
	const frustum  frs = ds.get_frustum();
	const double target_dist_sqr = norm2(target_pos - camera_pos);
	const float Rmax = 0.5*get_Rmax();
	const float Rth  = 0.5*Rmax;
	const nearby_galaxy2& gl = NGLX[idx];


	//-- draw
	glEnable(GL_BLEND);
	glDepthMask(GL_FALSE);
	glBindTexture(GL_TEXTURE_2D, texGalaxy);


	const float R_gal = gl.R;		// ͂̔a
	float sz = R_gal * ds.scale_factor;

	float af = af0;
	const float dist = rpos.norm();
	if (dist > Rth) {
		af = 1 - (dist-Rth)/(Rmax-Rth);
	}
	if (af < 0.01) return;

	glPushMatrix();
		//--  Go to the center of the galaxy
		glTranslatef(rpos.x, rpos.y, rpos.z);

		float M[16];
		glGetFloatv( GL_MODELVIEW_MATRIX, M);
		float r = sqrt( M[12]*M[12] + M[13]*M[13] + M[14]*M[14] );
		float sz2 = R_gal/scale /r*screen_z * 2000;
		if (sz2 < 0.5) sz=2;

		if (sz2 >= 0.5) {
			switch (gl.dtype) {
				case GALAXY_DRAW_TYPE_CD:
					draw_elliptical_galaxy(ds, rpos);
					break;
				default:
					glBlendFunc(GL_ONE, GL_ONE);

					glEnable(GL_TEXTURE_2D);
					if (bVirgoCluster && gl.group==11)	{ glColor4f(0.2,1,0.4,af); }
					else								{ glColor4f(af,af,af,af); }

					toward_eye_pos();
					glScalef(sz,sz,1);
					glCallList(dlGalaxy + gl.mtype);
					glDisable(GL_TEXTURE_2D);
					break;
			}
		}
	glPopMatrix();

	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glDisable(GL_TEXTURE_2D);
	glDepthMask(GL_TRUE);
}


void
draw_a_nearby_galaxy_as_point(const mtk_draw_struct& ds, int idx, const vector3d& rpos, float alpha)
{
	vector3f  rr = rpos;
	float R2;
	R2 = norm2(rr);
	if (R2 < 1e-100) return;


	const nearby_galaxy2& gl = NGLX[idx];


	glDisable(GL_TEXTURE_2D);
	glDisable(GL_LIGHTING);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);


	//float a = 0.1 / get_screen_z() * get_screen_w() / 180;

	float fac;
	if (bVirgoCluster && gl.group == 11)	{ glColor4f(0.2, 1.0, 0.4, alpha); fac = 1.167; }	// For Virgo cluster
	else									{ glColor4f(0.9, 0.9, 0.9, alpha); fac = 1.0; }


	if (true) {
		// QUAD
		vector3f eR, eU;
		if (ds.bRotateBillboard) {
			eR = gl.eR;
			eU = gl.eU;
		}
		else {
			eR = ds.eRf;
			eU = ds.eUf;
		}

		draw_point(ds, 0.0012, float(sqrt(R2)), rpos, eR, eU);
	} else {
		const float ptsz_scl = 1 / (ds.rad_per_pixel / 0.001);
		glPointSize(3.0*fac*ptsz_scl);

		glBegin(GL_POINTS);
			glVertex3dv( rpos.get_pointer() );
		glEnd();
	}
}




//--------
//  Info
//--------
void
make_object_info_nearby_galaxy(const mtk_draw_struct& ds, int idx, std::vector<std::string>& text)
{
	bool bEnglish = (ds.lang == LANG_ENG);
	char str[256], name2[256];
	
	const nearby_galaxy2& gl = NGLX[idx];



	if (gl.label_obj_idx != -1) {
		const mtk_object& obj = get_object( gl.label_obj_idx );
		text.push_back( get_label_text( obj.get_index(), bEnglish  ) );
	}
	

	name2[0] = '\0';
	switch (gl.chCatalogue) {
		case 'N':	//  NGC
			sprintf(name2, "NGC%d", gl.Catalogue_no);
			break;
		case 'U':	//  UGC
			sprintf(name2, "UGC%d", gl.Catalogue_no);
			break;
		case 'P':	// PGC
			sprintf(name2, "PGC%d", gl.Catalogue_no);
			break;
		case 'T':	// Tully
		case '*':	// Undefined
		default:
			break;
	}
	if (gl.label_obj_idx == -1 && name2[0]=='\0') {
		if (bEnglish)	{ strcpy(name2, "Galaxy"); }
		else			{ strcpy(name2, "" ); 	}
	}
	if (name2[0] != '\0') {
		text.push_back( name2 );
	}


	const char szTypeE[][30] = {
		"Galaxy",
		"Elliptical Galaxy",
		"S0 Galaxy",
		"Spiral Galaxy",
		"Irregular Galaxy",
		"Spiral Galaxy",
		"Spiral Galaxy",
		"Spiral Galaxy"
	};

	const char szTypeJ[][30] = {
		"",
		"ȉ~",
		"S0",
		"Q",
		"sK",
		"Q",
		"Q",
		"Q"
	};


	if (bEnglish) {
		sprintf(str, "Type: %s", szTypeE[gl.mtype]);
	} else {
		sprintf(str, "ށF%s", szTypeJ[gl.mtype]);
	}
	text.push_back(str);
}





//----------
//  Number
//----------
int
get_number_of_nearby_galaxies()
{
	return  NGLX.size();
}

