/**************************************************************************************************

Copyright (c) 2007, 2015   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  <windows.h>
#include  "mtk_planetary_ring.h"
#include  "../common/astro/cele_mech.h"
#include  "mtk_planet_position.h"
#include  "mtk_planet_phys_params.h"
#include  "mtk_planet_orientation.h"



// x
static float frac[particle_ring_RN][particle_ring_PHIN + 1];




// _
enum {
	PT1,
	PT2,
	PT3,
	PT4,
	PTC1,
	PTC2
};


// _̃p^[
enum {
	CODE_12_13 = 0x3,
	CODE_12_24 = 0x5,
	CODE_13_34 = 0xA,
	CODE_24_34 = 0xC,
	CODE_12_34 = 0x9,
	CODE_13_24 = 0x6
};

enum {
	CP_12_13,
	CP_12_24,
	CP_13_34,
	CP_24_34,
	CP_12_34,
	CP_13_24
};


// `p̒_
struct tri_index {
	int N1;
	int idx1[5];
	int N2;
	int idx2[5];
};

const tri_index tri_idx[6] = {
	{3, {PT1, PTC1, PTC2, 0, 0}, 5, {PTC1, PT2, PTC2, PT4, PT3}},
	{5, {PTC1, PT1, PTC2, PT3, PT4}, 3, {PT2, PTC1, PTC2, 0, 0}},
	{5, {PT1, PT2, PTC1, PT4, PTC2}, 3, {PTC1, PTC2, PT3, 0, 0}},
	{5, {PT2, PTC1, PT1, PTC2, PT3}, 3, {PTC1, PTC2, PT4, 0, 0}},
	{4, {PT1, PTC1, PT3, PTC2, 0}, 4, {PTC1, PT2, PTC2, PT4, 0}},
	{4, {PT1, PT2, PTC1, PTC2, 0}, 4, {PTC1, PTC2, PT3, PT4, 0}}
};




//-------------------
//  Planetary Rings
//-------------------

// a͘f̔aŋKi
particle_ring::particle_ring(float _R1, float _R2) : R1(_R1), R2(_R2), last_mode(-1), JD(0.0)
{
	for (int i=0; i<particle_ring_RN; i++) {
		s[i] = float(i)/(particle_ring_RN-1);
		const float r = (R2-R1) * float(i) / (particle_ring_RN-1) + R1;

		for (int j=0; j<=particle_ring_PHIN; j++) {
			const float phi  = 2*M_PI * float(j)/particle_ring_PHIN;

			float x, y;
			x = r *cosf(phi);
			y = r *sinf(phi);

			pos[i][j].set(x,y,0.0f);
		}
	}

}





//--------------
//  e̐
//--------------
void
particle_ring::calc_shadow_factor(const mtk_draw_struct& ds, int plnt_idx, const vector3d& rs)
{
	// ȑǑvZ玞ƃ[hςĂȂƂ͍ČvZȂ
	if (last_mode != -1) {
		if (last_mode == ds.tyMode && JD == ds.JD) {
			return;
		}
	}
	last_mode = ds.tyMode;
	JD = ds.JD;



	vector3d r0, ex, ey, ez, _rs, nv;
	double R, f, a, _x, _y, _z;


	r0 = get_planet_position(plnt_idx);
	R  = get_planet_Re(ds.tyMode, plnt_idx) * _1km_pc;
	get_planet_bases(plnt_idx, ex, ey, ez);


	// fɂȂ悤ɎɃXP[Wnł̌̈ʒu߂
	f = get_planet_f(plnt_idx);
	a = 1.0 / (1.0 - f); // -Z(>1)

	_rs = rs - r0;		// f_ɂWnł̌̈ʒu
	_x = dot_product(ex, _rs);
	_y = dot_product(ey, _rs);
	_z = dot_product(ez, _rs);
	
	_rs.set(_x, _y, a*_z);	// fWnł̌̈ʒuiȉAfWnŌvZj
	nv = normalize(-_rs);	// xNg
	

	double sinth, costh;
	sinth = R / norm(_rs);
	costh = sqrt(1.0 - sinth*sinth);


	for (int i = 0; i<particle_ring_RN; i++) {
		for (int j = 0; j <= particle_ring_PHIN; j++) {

			vector3d dr = R * vector3d(pos[i][j]);
			if (dot_product(dr, nv) < 0.0) {
				shadow_fac[i][j] = -1.0;
				continue;
			}

			vector3d n = normalize(dr - _rs);
			shadow_fac[i][j] = dot_product(n, nv) / costh - 1.0;
		}
	}

	for (int i = 0; i<particle_ring_RN-1; i++) {
		for (int j = 0; j < particle_ring_PHIN; j++) {
			bool b1, b2, b3, b4;

			b1 = (shadow_fac[i][j] > 0.0);
			b2 = (shadow_fac[i+1][j] > 0.0);
			b3 = (shadow_fac[i][j+1] > 0.0);
			b4 = (shadow_fac[i+1][j+1] > 0.0);

			if ((b1 && b2 && b3 && b4) || (!b1 && !b2 && !b3 && !b4)) {
				b_shadow_boundary[i][j] = false;
			}
			else {
				b_shadow_boundary[i][j] = true;
			}
		}
	}
}





//--------
//  `
//--------
void
particle_ring::draw_triangles(const vector2f* pt, const float *u, const float *f, const int *pt_idx, const int N, bool bShadow) const
{
	glBegin(GL_TRIANGLE_STRIP);


	if (bShadow) {
		glColor3f(0, 0, 0);

		for (int i = 0; i < N; i++) {
			int idx;

			idx = pt_idx[i];
			glTexCoord2f(u[idx], 0);
			glVertex2fv(pt[idx].get_pointer());
		}

	}
	else {
		for (int i = 0; i < N; i++) {
			int idx;
			float lv;

			idx = pt_idx[i];
			lv = f[idx];
			glColor3f(lv, lv, lv);
			glTexCoord2f(u[idx], 0);
			glVertex2fv(pt[idx].get_pointer());
		}
	}

	glEnd();
}


void
particle_ring::draw_boundary_mesh(int i, int j) const
{
	// _̈ʒu
	vector2f pt[6];
	pt[PT1] = vector2d(pos[i][j].x, pos[i][j].y);
	pt[PT2] = vector2d(pos[i + 1][j].x, pos[i + 1][j].y);
	pt[PT3] = vector2d(pos[i][j + 1].x, pos[i][j + 1].y);
	pt[PT4] = vector2d(pos[i + 1][j + 1].x, pos[i + 1][j + 1].y);

	// eNX`W
	float u[6];
	u[PT1] = u[PT3] = s[i];
	u[PT2] = u[PT4] = s[i + 1];

	// x
	float f[6];
	f[PT1] = frac[i][j];
	f[PT2] = frac[i + 1][j];
	f[PT3] = frac[i][j + 1];
	f[PT4] = frac[i + 1][j + 1];
	
	// eq
	float sf[4];
	sf[PT1] = shadow_fac[i][j];
	sf[PT2] = shadow_fac[i + 1][j];
	sf[PT3] = shadow_fac[i][j + 1];
	sf[PT4] = shadow_fac[i + 1][j + 1];


	//---  _̌vZ
	int idx = 0;
	int code = 0;
	int flg = 1;

	for (int k = 0; k < 4; k++) {
		const int edge_idx[4][2] = {{PT1, PT2}, {PT1, PT3}, {PT2, PT4}, {PT3, PT4}};	// 1-2, 1-3, 2-4, 3-4
		int i1, i2;
		i1 = edge_idx[k][0];
		i2 = edge_idx[k][1];

		// _̌vZ
		if (sf[i1] * sf[i2] < 0.0) {
			code |= flg;

			// eʂ̕ω
			vector2f edge = pt[i2] - pt[i1];
			float du = u[i2] - u[i1];
			float df = f[i2] - f[i1];

			// `Ԃ̈q
			float a = -sf[i1] / (sf[i2] - sf[i1]);

			pt[idx + 4] = a*edge + pt[i1];
			u[idx + 4] = a*du + u[i1];
			f[idx + 4] = a*df + f[i1];

			idx++;
		}

		flg <<= 1;
	}

	int cp_idx;
	switch (code) {
		case CODE_12_13:	cp_idx = CP_12_13;	break;
		case CODE_12_24:	cp_idx = CP_12_24;	break;
		case CODE_13_34:	cp_idx = CP_13_34;	break;
		case CODE_24_34:	cp_idx = CP_24_34;	break;
		case CODE_12_34:	cp_idx = CP_12_34;	break;
		case CODE_13_24:	cp_idx = CP_13_24;	break;
		default:	return;	// incorrect pattern
	}


	//---  `
	bool bShadow = (sf[PT1] > 0.0);
	const tri_index& ti = tri_idx[cp_idx];
	draw_triangles(pt, u, f, ti.idx1, ti.N1, bShadow);
	draw_triangles(pt, u, f, ti.idx2, ti.N2, !bShadow);
}



void
particle_ring::draw(const mtk_draw_struct& ds, int plnt_idx, const vector3d& rs)  const
{
	vector3d r, ex, ey, ez, cpos;
	double R;


	r = get_planet_position(plnt_idx);
	R = get_planet_Re(ds.tyMode, plnt_idx) * _1km_pc;
	get_planet_bases(plnt_idx, ex, ey, ez);
	cpos = ds.camera.get_pos();


	// x̌vZ
	for (int i = 0; i<particle_ring_RN; i++) {
		for (int j = 0; j <= particle_ring_PHIN; j++) {
			const vector3f&  pos_pl = pos[i][j];

			double x, y;
			x = R * pos_pl.x;
			y = R * pos_pl.y;

			vector3d pos;
			pos = x*ex + y*ey + r;


			// xvZ
			const vector3d nv = normalize(pos - cpos);
			const vector3d lv_e = normalize(pos - rs);
			float dp = dot_product(lv_e, nv);
			float th = acosf(dp);

			frac[i][j] = 1.0 - th / M_PI;
		}
	}


	// `
	glPushAttrib(GL_ENABLE_BIT);
	glDisable(GL_LIGHTING);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glDisable(GL_CULL_FACE);
	glEnable(GL_DEPTH_TEST);


	for (int i = 0; i<particle_ring_RN - 1; i++) {
		for (int j = 0; j<particle_ring_PHIN; j++) {
			float f;

			if (b_shadow_boundary[i][j]) {
				draw_boundary_mesh(i, j);
				continue;
			}

			glBegin(GL_TRIANGLE_STRIP);

			if (shadow_fac[i][j] > 0.0) {
				// e̒

				glColor3f(0, 0, 0);

				glTexCoord2f(s[i], 0);
				glVertex3fv(pos[i][j].get_pointer());

				glTexCoord2f(s[i + 1], 0);
				glVertex3fv(pos[i + 1][j].get_pointer());

				glTexCoord2f(s[i], 0);
				glVertex3fv(pos[i][j + 1].get_pointer());

				glTexCoord2f(s[i + 1], 0);
				glVertex3fv(pos[i + 1][j + 1].get_pointer());
			}
			else {
				// e̊O

				f = frac[i][j];
				glColor3f(f, f, f);
				glTexCoord2f(s[i], 0);
				glVertex3fv(pos[i][j].get_pointer());

				f = frac[i + 1][j];
				glColor3f(f, f, f);
				glTexCoord2f(s[i + 1], 0);
				glVertex3fv(pos[i + 1][j].get_pointer());

				f = frac[i][j + 1];
				glColor3f(f, f, f);
				glTexCoord2f(s[i], 0);
				glVertex3fv(pos[i][j + 1].get_pointer());

				f = frac[i + 1][j + 1];
				glColor3f(f, f, f);
				glTexCoord2f(s[i + 1], 0);
				glVertex3fv(pos[i + 1][j + 1].get_pointer());
			}
			
			glEnd();
		}
		//glEnd();
	}
	glPopAttrib();
}



// fSɈړBf̔aŃXP[OBf̐ԓW
void
particle_ring::draw_3Dchart()  const
{
	float lp[4];
	glGetLightfv(GL_LIGHT0, GL_POSITION, lp);	// _Wnł̌̈ʒu
	const vector3f lv_e = normalize(vector3f(lp[0], lp[1], lp[2]));	// s



	float M[16];
	glGetFloatv(GL_MODELVIEW_MATRIX,  M);


    // x̌vZ
	for (int i=0; i<particle_ring_RN; i++) {
		for (int j=0; j<=particle_ring_PHIN; j++) {
			const vector3f&  pos_pl = pos[i][j];

			float x, y;
			x = pos_pl.x;
			y = pos_pl.y;

			// _Wnł̗vf̈ʒuxNg
			vector3f  pos_e;
			pos_e.x = M[0]*x + M[4]*y + M[12];
			pos_e.y = M[1]*x + M[5]*y + M[13];
			pos_e.z = M[2]*x + M[6]*y + M[14];

			// xvZ
			const vector3f nv = normalize(-pos_e);
			float dp = dot_product(lv_e, nv);		// s
			float th = acosf(dp);

			frac[i][j] = 1.0 - th / M_PI;
		}
	}


	// `
	glPushAttrib(GL_ENABLE_BIT);
	glDisable(GL_LIGHTING);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glDisable(GL_CULL_FACE);


	for (int i=0; i<particle_ring_RN-1; i++) {
		glBegin(GL_TRIANGLE_STRIP);
		for (int j=0; j<particle_ring_PHIN; j++) {
			float f;

			f = frac[i][j];
			glColor3f(f,f,f);
			glTexCoord2f(s[i], 0);
			glVertex3fv(pos[i][j].get_pointer());

			f = frac[i+1][j];
			glColor3f(f,f,f);
			glTexCoord2f(s[i+1], 0);
			glVertex3fv(pos[i+1][j].get_pointer());

			f = frac[i][j+1];
			glColor3f(f,f,f);
			glTexCoord2f(s[i], 0);
			glVertex3fv(pos[i][j+1].get_pointer());

			f = frac[i+1][j+1];
			glColor3f(f,f,f);
			glTexCoord2f(s[i+1], 0);
			glVertex3fv(pos[i+1][j+1].get_pointer());
		}
		glEnd();
	}
	glPopAttrib();
}




