/******************************************************************************

Copyright (c) 2007-2015   Tsunehiko Kato

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEF
Avj̕擾邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ
܂Bɂ́A\tgEFA̕gpAʁAύXAAfځAЕzATu
CZXA/܂͔̔錠Aу\tgEFA񋟂鑊ɓ
Ƃ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕ
Lڂ̂Ƃ܂B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂
񋟂܂Błۏ؂Ƃ́AiA̖ړIւ̓KAьN
QɂĂ̕ۏ؂܂݂܂AɌ肳̂ł͂܂B ҂܂͒
쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\tgEFAɋN܂
֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
*******************************************************************************/
#include  "gltext.h"


#define DEBUG_BOX 0


//--- ̃TCY𓾂 ---
int
gltext::get_string_size(const char* p, wgl_font& fnt, gltext_block_size& sz)
{
	float w, h;
	int n;	// 
	n = 0;
	w = h = 0;
	while (*p != '\0') {
		float dw, dh;
		if (*(p+1) != '\0' && isMB(*p, *(p+1))) {
			//-- }`oCg̃TCY
			fnt.get_glyph_size_MB(*p, *(p+1), dw, dh);
			p+=2;
		} else {
        	//-- ʏ̂PoCg̃TCY
			fnt.get_glyph_size_SB(*p, dw, dh);
			p++;
		}
		w += dw;
		h = max(h, dh);
		n++;
	}
	sz.w  = sze * w;
	sz.hu = sze * h;
	sz.hd = 0.0;
	return n;
}


//--- R}h̃TCY𓾂 ---
int
gltext::get_command_size(const ctext_command& cmd, wgl_font& fnt, gltext_block_size& sz)
{
	float w, h;
	int n;	// 
	n = 0;
	w = h = 0.0;
	const tagCTEXT_CTRL_CODE& cc = CTEXT_CTRL_CODE[cmd.idx];
	int ID = cc.ID;

	switch (ID) {
		case CCMD_CDOT:
			{
				w = h = 1;
				n = 1;
			}
			break;
		case CCMD_COPYRIGHT:
			{
				w = h =1;
				n = 1;
			}
			break;
		case CCMD_SIZE:
			if (cmd.optf.size() > 0) {
				sze = cmd.optf[0];
			}
			break;
		case CCMD_RSIZE:
			if (cmd.optf.size() > 0) {
				sze *= cmd.optf[0];
			}
			break;
		case CCMD_HSPACE:
			if (cmd.optf.size() > 0) {
			w = cmd.optf[0];
			}
			break;
		case CCMD_VSPACE:
			if (cmd.optf.size() > 0) {
				sz.w = 0;
				sz.hu = 0;
				sz.hd = -cmd.optf[0];
				return 0;
			}
			break;
		default:
			break;
	}
	sz.w  = sze*w;
	sz.hu = sze*h;
	sz.hd = 0.0;
	return n;
}


//--- Gg̃TCY𓾂 ---
int
gltext::get_element_size(int& icode, wgl_font& fnt, gltext_block_size& elsz)
{
	int n;
	n = 0;
	elsz.w = elsz.hu = elsz.hd = 0.0;

	bool bTable = false;
	while (icode < vCode.size()) {
		const ctext_code& code = vCode[icode];
		gltext_block_size sz;
		sz.w = sz.hu = sz.hd = 0.0;
		switch (code.type) {
			case CTEXTCODE_STRING:
				n += get_string_size(vString[code.idx].c_str(), fnt, sz);
				break;
			case CTEXTCODE_COMMAND:
				{
					const ctext_command& cmd = vCommand[code.idx];
					const tagCTEXT_CTRL_CODE& cc = CTEXT_CTRL_CODE[cmd.idx];
					
					if (cc.ID==CCMD_TABLE) {
						float w = 0;
						for (int i=0; i<cmd.optf.size(); i++) {
							w += sze*cmd.optf[i];
						}
						if (elsz.w < w)  elsz.w = w;
						
						bTable = true;
						icode++;
						continue;
					}
					n += get_command_size(cmd, fnt, sz);
				}
				break;
			case CTEXTCODE_ENTER_BLOCK:
				{
					float sze0 = sze;
					icode++;
					get_block_size(icode, fnt, sz);
					n++;	// TuEubN1Ɠ
					sze = sze0;
				}
				break;
			case CTEXTCODE_NEW_LINE:
			case CTEXTCODE_UPWARD_NEW_LINE:
				//-- through down --
			case CTEXTCODE_LEAVE_BLOCK:
				return n;
		}
		if (!bTable) elsz.w   += sz.w;
		elsz.hu  = max(elsz.hu, sz.hu);
		elsz.hd  = min(elsz.hd, sz.hd);
		icode++;
	}
	return n;
}


//--- ubÑTCY𓾂 ---
int
gltext::get_block_size(int& icode, wgl_font& fnt, gltext_block_size& bsz)
{
	int n;
	n = 0;
	bsz.w = bsz.hu = bsz.hd = 0.0;
	bool bUpward = true;
	while (icode < vCode.size()) {
		const ctext_code& code = vCode[icode];
		switch (code.type) {
			case CTEXTCODE_LEAVE_BLOCK:
				return n;
			case CTEXTCODE_NEW_LINE:
				bUpward = false;
				icode++;
				continue;
			case CTEXTCODE_UPWARD_NEW_LINE:
				bUpward = true;
				icode++;
				continue;
			default:
				break;
		}
		gltext_block_size  elsz;
		get_element_size(icode, fnt, elsz);
		bsz.w  = max(bsz.w, elsz.w);
		if (bUpward)	{ bsz.hu += (elsz.hu - elsz.hd); }
		else			{ bsz.hd -= (elsz.hu - elsz.hd); }
		n++;
	}
	return n;
}


//---
void
gltext::set_element(int icode, wgl_font& fnt)
{
	//
	int align_mode = cur_blk.align_mode;
	if (vCode[icode].type == CTEXTCODE_COMMAND) {
		const ctext_code& code = vCode[icode];
		const tagCTEXT_CTRL_CODE& cc = CTEXT_CTRL_CODE[vCommand[code.idx].idx];
		switch (cc.ID) {
			case CCMD_ALIGN_LEFT:
				align_mode = CTEXT_ALIGN_LEFT;
				break;
			case CCMD_ALIGN_CENTER:
				align_mode = CTEXT_ALIGN_CENTER;
				break;
			case CCMD_ALIGN_RIGHT:
				align_mode = CTEXT_ALIGN_RIGHT;
				break;
			case CCMD_ALIGN_KINTOU:
				align_mode = CTEXT_ALIGN_KINTOU;
				break;
			default:
				break;
		}
	}

	int n;
	sze = cur_blk.size;
	n = get_element_size(icode, fnt, cur_blk.esz);

	//--- ̑蕝ݒ肷 ---
	if (align_mode == CTEXT_ALIGN_LEFT) {		//-- 
		cur_blk.D = 0.0;
	} else if (align_mode == CTEXT_ALIGN_CENTER) {	//-- 
		cur_blk.D = 0.0;
		float skip_x = 0.5 * cur_blk.size * (cur_blk.bsz.w-cur_blk.esz.w);
		glTranslatef(skip_x,0,0);
		cx += skip_x;
		if (cx > cur_blk.x2)  { cur_blk.x2 = cx; }
	} else if (align_mode == CTEXT_ALIGN_RIGHT)	{
		cur_blk.D = 0.0;
		float skip_x = cur_blk.size * (cur_blk.bsz.w-cur_blk.esz.w);
		glTranslatef(skip_x,0,0);
		cx += skip_x;
		if (cx > cur_blk.x2)  { cur_blk.x2 = cx; }
	} else {									//-- ϓt
		if (n <= 1) {
			cur_blk.D = 0.0;
			float skip_x = sze * (cur_blk.bsz.w-cur_blk.esz.w);
			glTranslatef(skip_x,0,0);
			cx += skip_x;
			if (cx > cur_blk.x2)  { cur_blk.x2 = cx; }
		} else {
			cur_blk.D = (cur_blk.bsz.w-cur_blk.esz.w) / float(n-1);
		}
	}
	sze = cur_blk.size;
}


//--- ̕\ ---
void
gltext::draw_string(const char* p, wgl_font& fnt)
{
	float dw, dh, w;
	glPushMatrix();
		const float& sz = cur_blk.size;
		const float  D2 = cur_blk.D/sz;
		glScalef(sz,sz,sz);
		w = 0.0;
		while (*p != '\0') {
			if (*(p+1) != '\0' && isMB(*p, *(p+1))) {
				//-- }`oCg̕\
				fnt.draw_char_MB(*p, *(p+1));
				fnt.get_glyph_size_MB(*p, *(p+1), dw, dh);
				p+=2;
			} else {
	        	//-- ʏ̂PoCg̕\
				fnt.draw_char_SB(*p);
				fnt.get_glyph_size_SB(*p, dw, dh);
				p++;
			}
			glTranslatef(D2,0,0);
			w += dw;
			if (*p != '\0')  w += cur_blk.D;
		}
	glPopMatrix();
	glTranslatef(sz*w,0,0);
	cx += sz*w;
	if (cx > cur_blk.x2)  { cur_blk.x2 = cx; }
}


//--- ꕶ̕` ---
void
gltext::draw_special_char(int ID, wgl_font& fnt)
{
	float w;
	w = 0.0;
	glPushMatrix();
		const float& sz = cur_blk.size;
		glScalef(sz,sz,sz);
		switch (ID) {
			case CCMD_CDOT:			//--- _
				{
					const float R = 0.1;
					glPushMatrix();
						glTranslatef(0.5, 0.3, 0);
						glBegin(GL_TRIANGLE_FAN);
							glVertex3f(0,0,0);
							for (int i=0; i<=360; i+=30) {
								glVertex3f(R*cos(D2R*i), R*sin(D2R*i), 0);
							}
						glEnd();
					glPopMatrix();
					w += 1 + cur_blk.D;
				}
				break;
			case CCMD_COPYRIGHT:	//--- Rs[CgL
				{
					const float R1 = 0.35;
					const float R2 = 0.45;
					glPushMatrix();
						glPushMatrix();
							glTranslatef(0.5, 0.3, 0);
							glBegin(GL_TRIANGLE_STRIP);
								for (int i=0; i<=360; i+=30) {
									float cs = cos(D2R*i);
									float sn = sin(D2R*i);
									glVertex3f(R1*cs, R1*sn, 0);
									glVertex3f(R2*cs, R2*sn, 0);
								}
							glEnd();
						glPopMatrix();
						float _w, _h;
						fnt.get_glyph_size_SB('c', _w, _h);
						glTranslatef(0.5*(1-_w), 0.1, 0);
						fnt.draw_char_SB('c');
					glPopMatrix();
					w += 1 + cur_blk.D;
				}
				break;
			default:
				break;
		}
	glPopMatrix();
	glTranslatef(sz*w,0,0);
	cx += sz*w;
	if (cx > cur_blk.x2)  { cur_blk.x2 = cx; }
}


//--- R}h̏ ---
void
gltext::process_command(int idx, wgl_font& fnt)
{
	const ctext_command& cmd = vCommand[idx];
	const tagCTEXT_CTRL_CODE& cc = CTEXT_CTRL_CODE[cmd.idx];
	switch (cc.ID) {
		case CCMD_ALIGN_LEFT:
			cur_blk.align_mode = CTEXT_ALIGN_LEFT;
			break;
		case CCMD_ALIGN_KINTOU:
			cur_blk.align_mode = CTEXT_ALIGN_KINTOU;
			break;
		case CCMD_COLOR:		//--- F̐ݒ
			{	
				RGBAf col;
				for (int i=0; i<3; i++) {
					col.rgba[i] = (i < cmd.optf.size())  ?  cmd.optf[i]  :  0.0;
				}
				col.rgba[3] = (cmd.optf.size() >= 4)  ?  cmd.optf[3]  :  1.0;
				set_color(col);
			}
			break;
		case CCMD_SIZE:
			if (cmd.optf.size() < 1) break;
			set_size(cmd.optf[0]);
			break;
		case CCMD_RSIZE:
			if (cmd.optf.size() < 1) break;
			set_relative_size(cmd.optf[0]);
			break;
		case CCMD_VSPACE:
			if (cmd.optf.size() >= 1) {
				float sz = cur_blk.size;
				glTranslatef(0, -sz * cmd.optf[0], 0);
			}
			break;
		case CCMD_HSPACE:
			if (cmd.optf.size() >= 1) {
				float sz = cur_blk.size;
				glTranslatef(sz * cmd.optf[0], 0, 0);
				cx += sz * cmd.optf[0];
				if (cx > cur_blk.x2) { cur_blk.x2 = cx; }
				if (cx < cur_blk.x1) { cur_blk.x1 = cx; }
			}
			break;
		case CCMD_TABLE:
			{
				const float sz = cur_blk.size;
				cur_blk.vTabStop.clear();
				cur_blk.tab_count = 0;
				float tab_pos = 0.0;
				for (int i=0; i<cmd.optf.size(); i++) {
					tab_pos += sz*cmd.optf[i];
					cur_blk.vTabStop.push_back(tab_pos);
				}
			}
			break;
		case CCMD_DELIMITER:
			{	if (cur_blk.tab_count + 1 >= cur_blk.vTabStop.size()) break;
				float tab_pos = cur_blk.vTabStop[cur_blk.tab_count++];
				glTranslatef(-(cx-cur_blk.x1) + tab_pos,0,0);
				cx = cur_blk.x1 + tab_pos;
			}
			break;
		case CCMD_CDOT:			//--- _
		case CCMD_COPYRIGHT:	//--- Rs[CgL
			draw_special_char(cc.ID, fnt);
			break;		
		default:
			break;
	}
}


//--- ` ---
void
gltext::draw0(const gltext_block_info& root_blk, wgl_font& fnt)
{
	cur_blk = root_blk;
	// ݂̐F擾
	glGetFloatv(GL_CURRENT_COLOR, cur_blk.color.get_pointer() );
	set_color(cur_blk.color);
	//グ
	glTranslatef(0, -cur_blk.bsz.hd, 0);

	int icode0;
	icode0 = 0;
	set_element(icode0, fnt);
	for (int icode = 0; icode<vCode.size(); icode++) {
		const ctext_code& code = vCode[icode];
		switch (code.type) {
			case CTEXTCODE_STRING:
				draw_string(vString[code.idx].c_str(), fnt);
				break;
			case CTEXTCODE_COMMAND:
				process_command(code.idx, fnt);
				break;
			case CTEXTCODE_ENTER_BLOCK:
				{
					vBlock.push_back(cur_blk);
					int elems;
					int icode1 = icode + 1;
					sze = cur_blk.size;
					elems = get_block_size(icode1, fnt, cur_blk.bsz);
					cur_blk.x1 = cx;
					cur_blk.x2 = cur_blk.x1 + cur_blk.bsz.w;
					cur_blk.vTabStop.clear();
					cur_blk.tab_count = 0;
					if (icode+1 < vCode.size()) {
						// ŏ̃Gg̃TCY
						set_element(icode+1, fnt);
					}
				}
				break;
			case CTEXTCODE_LEAVE_BLOCK:
				{
					// ̃ubN̉E[܂Ői߂
					glTranslatef(cur_blk.x2-cx, -cy, 0);
					cx = cur_blk.x2;
					cur_blk = vBlock.back();
					vBlock.pop_back();
					if (cx > cur_blk.x2)  { cur_blk.x2 = cx; }
					sze = cur_blk.size;
					cy = 0;
					set_color(cur_blk.color);
				}
				break;
			case CTEXTCODE_NEW_LINE:
				{
					sze = cur_blk.size;
					glTranslatef(-(cx-cur_blk.x1),0,0);
					cx = cur_blk.x1;
					cy = cur_blk.size;
					cur_blk.tab_count = 0;
					if (icode+1 < vCode.size()) {
						// Gg̃TCY
						set_element(icode+1, fnt);
						glTranslatef(0, -cur_blk.esz.hu, 0);
					}
				}
				break;
			case CTEXTCODE_UPWARD_NEW_LINE:
				{
					sze = cur_blk.size;
					glTranslatef(-(cx-cur_blk.x1),0,0);
					cx = cur_blk.x1;
					glTranslatef(0,cur_blk.esz.hu,0);
					cy = cur_blk.size;
					cur_blk.tab_count = 0;
					if (icode+1 < vCode.size()) {
						// ̃Gg̃TCY
						set_element(icode+1, fnt);
					}
				}
				break;
			case CTEXTCODE_NULL:
			default:
				break;
		}
	}
}


void
gltext::draw(wgl_font& fnt)
{
	gltext_block_info  blk;
	blk.size = 1.0;
	blk.align_mode = CTEXT_ALIGN_LEFT;
	int icode0 = 0;
	sze = blk.size;
	get_block_size(icode0, fnt, blk.bsz);
	blk.x1 = 0.0;
	blk.x2 = 0.0;
	cx = 0;
	cy = 0;
	cur_blk.x1 = 0;
	cur_blk.x2 = cur_blk.x1 + cur_blk.bsz.w;
	draw0(blk, fnt);
}


void
gltext::draw_center(float w, wgl_font& fnt)
{
	gltext_block_info  blk;
	blk.size = 1.0;
	blk.align_mode = CTEXT_ALIGN_CENTER;
	int icode0 = 0;
	sze = blk.size;
	get_block_size(icode0, fnt, blk.bsz);
	blk.x1 = 0.0;
	blk.x2 = w;
	blk.bsz.w = w;
	cx = 0;
	cy = 0;
	cur_blk.x1 = 0;
	cur_blk.x2 = cur_blk.x1 + cur_blk.bsz.w;
	draw0(blk, fnt);
}


void
gltext::draw_right(float w, wgl_font& fnt)
{
	gltext_block_info  blk;
	blk.size = 1.0;
	blk.align_mode = CTEXT_ALIGN_RIGHT;
	int icode0 = 0;
	sze = blk.size;
	get_block_size(icode0, fnt, blk.bsz);
	blk.x1 = 0.0;
	blk.x2 = w;
	blk.bsz.w = w;
	cx = 0;
	cy = 0;
	cur_blk.x1 = 0;
	cur_blk.x2 = cur_blk.x1 + cur_blk.bsz.w;
	draw0(blk, fnt);
}


void
gltext::draw_kintou(float w, wgl_font& fnt)
{
	gltext_block_info  blk;
	blk.size = 1.0;
	blk.align_mode = CTEXT_ALIGN_KINTOU;
	int icode0 = 0;
	sze = blk.size;
	get_block_size(icode0, fnt, blk.bsz);
	blk.x1 = 0.0;
	blk.x2 = w;
	blk.bsz.w = w;
	cx = 0;
	cy = 0;
	cur_blk.x1 = 0;
	cur_blk.x2 = cur_blk.x1 + cur_blk.bsz.w;
	draw0(blk, fnt);
}


//----------------
//  X̃R}h
//----------------

//--- F̐ݒ ---
void
gltext::set_color(const RGBAf& col)
{
	glColor4fv( col.get_pointer() );
	cur_blk.color = col;
}

//--- TCY̐ݒ ---
void
gltext::set_size(float size)
{
	cur_blk.size  = size;
}

void
gltext::set_relative_size(float rsize)
{
	cur_blk.size  *= rsize;
}
